/*
    $Id: dump.h,v 1.6 2001/11/22 15:18:33 sensei Exp $

    Copyright (C) 2000-2001  Marko Zivanovic
 
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
 
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#ifndef DUMP_H

#include <ctype.h>
#include <sys/time.h>
#include <sys/resource.h>
#include <assert.h>
#include <errno.h>
#include <unistd.h>
#include <pthread.h>

#include "frames.h"
#include "helper.h"
//#include "sniffer.h"
#include "config.h"
#include "log.h"
#include "scripting.h"

extern FILE *fout;
extern int debug_malloc;
extern int stop_dumper, immediate_dump;

extern long total_pkts_sniffed, total_pkts_buffered;
extern long total_mem_sniffed, total_mem_buffered;

typedef struct {
  char *ID;
  char *script;
  int state;
  Tcl_Interp* interp;
  pthread_t thread;
  int priority;
  int dump_freq;
  long dump_size;
  long dump_packets;
  long buffered_mem;
  long buffered_pkts;
} dumper;

/* chain buffer */
typedef struct {
  eth_ip_frame *eth_ip_frame;
  char* dumperID;
  void* next;
} chain_buffer;

extern chain_buffer *cb_first;
extern chain_buffer *cb_last;

#define MAX_DUMPERS 1024
extern int no_dumpers;
extern dumper dumpers[MAX_DUMPERS];

enum DSTATE {
  DSTATE_RUNNING = 0,
  DSTATE_PAUSED,
  DSTATE_DELETE,
  DSTATE_DELETED
};

int add_dumper (ClientData, Tcl_Interp*, int, char**);
int pause_dumper (ClientData, Tcl_Interp*, int, char**);
int resume_dumper (ClientData, Tcl_Interp*, int,  char**);
int delete_dumper (ClientData, Tcl_Interp*, int, char**);

dumper* find_dumper (char*);

void* start_dumper (void*);
int dump_buffer ();

#define DUMP_H
#endif
