/*
    $Id: sniffer.h,v 1.8 2001/11/22 15:18:33 sensei Exp $

    Copyright (C) 2000-2001  Marko Zivanovic
 
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
 
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#ifndef SNIFFER_H

#include "../config.h"

#ifdef HAVE_UNISTD_H
#include <unistd.h>
#else
#error "Cannot #include <unistd.h>"
#endif

#ifndef HAVE_SOCKET
#error "This system doesn't have socket() function! Aborting compilation."
#endif

#ifdef HAVE_SYS_IOCTL_H
#include <sys/ioctl.h>
#else
#error "Cannot #include <sys/ioctl.h>"
#endif

#ifdef HAVE_PCAP_H
#include <pcap.h>
#endif

#include <net/if.h>
#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>
#include <sys/time.h>
#include <sys/resource.h>
#include <signal.h>
#include <time.h>
#include <errno.h>

#include "dump.h"
#include "frames.h"
#include "log.h"
#include "scripting.h"
#include "../config.h"

/*  configuration variables */
extern char device[];
extern int stop_sniffer;
extern int sniffer_priority;
extern int sock;

extern chain_buffer *cb_first;
extern chain_buffer *cb_last;

/* sniffer engine functions */
eth_ip_frame *read_eth_ip_frame (int, int);
void *start_sniffer (void *param);
int add_packet_to_buffer (char*, eth_ip_frame*);
int init_socket (char*);
void promisc_on (int, char*);
void promisc_off (int, char *);

#ifdef HAVE_PCAP_H
eth_ip_frame* read_eth_ip_frame_pcap (pcap_t*);
#endif

#define SNIFFER_H
#endif


