/*
    $Id: vshare.h,v 1.2 2001/11/18 10:33:59 sensei Exp $

    Copyright (C) 2001  Wojciech Kocjan
 
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
 
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#ifndef _USE_VSHARE_H_

#include <tcl.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <pthread.h>

#include "log.h"

extern pthread_mutex_t S_mutex;

int Vshare_Init (Tcl_Interp*);

enum {
    CMD_SET = 0,
    CMD_GET,
    CMD_UNSET,
    CMD_EVAL,
    CMD_END
};

static char *vs_cmds[] __attribute__ ((__unused__)) = {
    "set",
    "get",
    "unset",
    "eval",
    NULL
};

static Tcl_HashTable vs_hash __attribute__ ((__unused__));
struct vs_value {
    char *val;
    int len;
};

struct vs_value *vs_find_entry(char *ar, char *val, int mknew);
void vs_set_val(struct vs_value *v, char *nv, int l);
void vs_del_val(struct vs_value *v);

#define _USE_VSHARE_H_
#endif
